#ifndef __TIMER_H__
#define __TIMER_H__

#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <cuda_runtime.h>
#include <sys/time.h>

struct Timer {
  cudaEvent_t start_Evants;
  cudaEvent_t stop_Events;
  double Begin, Finish;
  double Total_OS;
  double Total_GPU;
  double elapsedTime_OS;
  float   elapsedTime_GPU ;//Used with cudaevenElapsedtime, only accepts float
  
  Timer();
  ~Timer();
  double clock_now();
  void Start();  
  void Reset();  
  void Stop(); 
};
#endif
