        module pTiming

        real*8 start_time, end_time
        real*8 reg_start, reg_end
        real*8 accumlated_mul        
	real*8 accumlated_building
 	character(len=7),parameter ::  tab = '       '
        end module
!Sets the measurement interface on the fortran side
!
!
       module measureGPU
       use Global
       implicit none

       integer :: dum                                                                         
 
       contains
!use this to call from the fortran
       subroutine  callOurMeasurement

       implicit none   

       dum = 1 
!       call MEASGPU(dum)

       end subroutine


       end module


!use this to call from the fortran




!Use for our printging debugin

	module debug

	use Global
	implicit none
		
	integer m,n,jc,ic, ind, imd, k
	integer, parameter ::  debug_enable = 0
	character(len=1024) :: cbuffer1

	contains

!determine what version of code is running
	subroutine chooseMode(filenameString, outString)
		implicit none	
         
	character(len=*) :: filenameString
	character(len=*) :: outString
	character(LEN=20) :: modeTag

	if (umode .eq. 4) then
		modeTag = '_cuda'
	else if (umode .eq. 1) then
		modeTag = '_fortran'
	end if

		modeTag = '' ! no need right now

	write(outString,'(3A)') '../debugIO/' ,  trim(filenameString) , '.dat'

	end subroutine

!subroutine meant to print out the gu and gd for comparison
	subroutine printGuAndGd(filename)
               
		!args
		character(len=*) :: filename
		!vars
		character(LEN=1024) :: outputFilenameGU
		character(LEN=1024) :: outputFilenameGD

		if (debug_enable .eq. 0) then
			return
		else
		
		end if

		write(cbuffer1,'(2A)') 'gu_', trim(filename)
		call chooseMode( cbuffer1, outputFilenameGU )
		write(cbuffer1,'(2A)') 'gd_', trim(filename)
		call chooseMode(  cbuffer1, outputFilenameGD )

		open(2314, file=outputFilenameGU, form='formatted')
   		open(2315, file=outputFilenameGD, form='formatted')

		do m=1,nl
        	do n=1,nl
          
        	do jc=1,Nc
        	do ic=1,Nc
          		ind=ic + (n-1)*Nc
          		imd=jc + (m-1)*Nc

			write(2314,'(4i4,f36.32)') m, n, jc, ic, gu(ind,imd)
       			write(2315,'(4i4,f36.32)') m, n, jc, ic, gd(ind,imd)

       		end do
        	end do
        	end do
        	end do

        	close(2314)
        	close(2315)

		end subroutine

!subroutine to print out ising field to compare
	subroutine printIsingField(filename)
                 
	!args
		character(len=*) :: filename
	!vars
		character(len=50) :: outputFilename

		if (debug_enable .eq. 0) then
			return
		else
		
		end if

		write(cbuffer1,'(2A)') 'ising_', trim(filename)
		call chooseMode( cbuffer1, outputFilename )
		open(2314, file=outputFilename, form='formatted')

		do m=1,nt
      		

			write(2314,'(I,I)') m,  s(m)
        
      		end do

		close(2314)

	
	end subroutine

!subrouitne to print out g_o for comparison
	subroutine printGscript(filename)
                
		character(len=*) :: filename
		character(len=50) :: outputFilename

		if (debug_enable .eq. 0) then
			return
		else
		
		end if


		write(cbuffer1,'(2A)') 'gscrt_', trim(filename)
		call chooseMode( cbuffer1, outputFilename )
		open(2314, file=outputFilename, form='formatted')
	do m=1,nl
        do n=1,nl 
          k=n-m
        do jc=1,Nc
        do ic=1,Nc
     

	write(2314,'(4i4,f36.32)') m, n, jc, ic, Gcst_not(k,ic,jc)
        
        end do
        end do
        end do
        end do

	close(2314)

	end subroutine



	end module


!Module for comparing fortran and cuda

	module comparison
		use Global
		implicit none

	


	end module
